ledmon(8)

NAME
ledmon - Intel(R) LED monitor service for storage enclosures.

SYNOPSIS
ledmon [OPTIONS]

DESCRIPTION
The ledmon application is a daemon process used to monitor a state of software RAID devices (md only) or a state of block devices. The state is visualizing on LEDs associated to each slot in an enclosure or a drive bay. There are two types of system: 2-LEDs system (Activity LED, Status LED) and 3-LEDs system (Activity LED, Locate LED, Fail LED). This application has the highest priority when accessing the LEDs.

The ledmon application supports LED management of the SAS/SATA and PCIe storages.

Supported protocols/methods for LED management are:

•   SES-2 and SMP for SAS devices,

•   LED messages over SGPIO for SATA,

•   VMD and NPEM for PCIe.

SAF-TE protocol is not supported.

For SAS/SATA storages supporting controllers may transmit LED management information to the backplane controllers via the SGPIO interface. The SGPIO bus carries bit patterns, which translate into LED blink patterns in accordance with the International Blinking Pattern Interpretation (IBPI) of SFF-8489 specification for SGPIO. Please note some enclosures do not stick close to the SFF-8489 specification. It might happen that the enclosure processor will accept the IBPI pattern but it will blink LEDs not according to SFF-8489 specification or it has a limited number of patterns supported.

For more information about communication methods please consult the appropriate Specifications.

There's no method provided to specify which RAID volume should be monitored and which not. The ledmon application monitors all RAID devices and visualizes their state.

The ledmon application has been verified to work with Intel(R) storage controllers (i.e. Intel(R) AHCI controller and Intel(R) SAS controller). The application might work with storage controllers of other vendors (especially SAS/SCSI controllers). However storage controllers of other vendors have not been tested.

The ledmon application is part of Intel(R) Enclosure LED Utilities. Only single instance of the application is allowed.

The ledmon utilizes the following documents as references:

•   SGPIO (Serial GPIO) - SFF-8485

•   IBPI (International Blinking Pattern Interpretation) - SFF-8489

•   LED Enclosure management messages - AHCI specification rev 1.3, section 12.2.1.

•   SAS (Serial Attached SCSI) - T10/1760-D

•   SES-2 (SCSI Enclosure Services-2) - T10/1559-D

•   SMP (Serial Management Protocol) - T10/1760-D

•   NPEM (Native PCIe Enclosure Management) - PCIe base specification rev 4.0

•   VMD (Intel(R) Volume Management Device) - Intel(R) VROC (VMD NVMe RAID) Quick Configuration Guide rev 1.2

OPTIONS

-c or --config=path
    Sets a path to local configuration file. If this option is specified the global configuration file and user configuration file has no effect.

-l or --log=path
    Sets a path to local log file. If this option is specified the global log file /var/log/ledmon.log is not used.

-t or --interval=seconds
    Sets time interval between scans of sysfs. The value is given in seconds. The minimum is 5 seconds the maximum is not specified.

--quiet or --error or --warning or --info or --debug or --all
    Verbose level - 'quiet' means no logging at all and 'all' means to log everything. The levels are given in order. If user specifies more then one verbose option the last option comes into effect. The default level is 'warning'. Verbose level also can be set by --log-level=level.

--foreground
    Run process foreground instead of a daemon. This option is useful in systemd service file. Another use case of this option is debugging with elevated --log-level=level.

-h or --help
    Prints this text out and exits.

-v or --version
    Displays version of ledmon and information about the license and exits.

FILES

/var/log/ledmon.log
    Global log file, used by ledmon application. To force logging to user defined file use -l option switch.

/etc/ledmon.conf
    Global configuration file, shared between ledmon and all ledctl application instances. Local configuration file can be used by running ledmon with -c switch.

LICENSE
Copyright (c) 2009-2022 Intel Corporation.

This program is distributed under the terms of the GNU General Public License as published by the Free Software Foundation. See the build-in help for details on the License and the lack of warranty.

BUGS
The ledmon application does not recognize PFA state (Predicted Failure Analysis), hence the PFA pattern from SFF-8489 specification is not visualized.

SEE ALSO
ledctl(8), ledmon.conf(5)

AUTHOR
This manual page was written by Artur Wojcik <artur.wojcik@intel.com>. It may be used by others.